/*
 * Created on 2003-10-22
 * User Interface part of code for TreeJuxtaposer 
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */


package TreeJuxtaposer;


import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import AccordionDrawer.*;
import Parser.status.*;


/**
 * @author jeffrey
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */


public class UI {
  Frame mainFrame;
  String title;
  StateFrame stateFrame;
  SettingsFrame settingsFrame;
  IncrementalSearch searchFrame;
  DebugFrame debugFrame;
  ButterflyFrame butterflyFrame;
  JPanel controlPanel;
  Panel drawPanel;
  GridLayout drawLayout;
  //screen size	   
  Toolkit toolkit = Toolkit.getDefaultToolkit();
  Dimension screendim = toolkit.getScreenSize();
  JFileChooser fc = new JFileChooser();
  boolean firstTime = true;


  /* Variables and constants for the menu bar */    
  MenuBar menuBar;
  MenuItem menuItem[][];
  static final String MENUFONTTYPE = "Helvetica";
  static final int MENUFONTSTYLE = Font.BOLD;
  static final int MENUFONTSIZE = 10;


  /* top-level menu bar constants */
  static final String menuHeader[] = {"File", "Find", "Tools", "Help"};
  static final int FILEMENU = 0;
  static final int FINDMENU = 1;
  static final int TOOLMENU = 2;
  static final int HELPMENU = 3;
  static final Menu menu[] = {new Menu(menuHeader[FILEMENU]),
    new Menu(menuHeader[FINDMENU]),
    new Menu(menuHeader[TOOLMENU]),
    new Menu(menuHeader[HELPMENU]),
  };   
  /* component-level menu bar constants
  * string to describe the menu options, null is for a separator
  * boolean to describe whether menu option is active
  * integer for enumerating menu options
  */


  static final String fileMenu[] = {"Open", "Delete", null, "Quit"};
  static final boolean fileActive[] = {true, true, false, true};
  static final int OPENOPT = 0;
  static final int DELETEOPT = 1;
  static final int QUITOPT = 3;
  
  static final String findMenu[] = {"Find"};
  static final boolean findActive[] = {true};
  static final int FINDOPT = 0;
    
  static final String toolMenu[] = {"Groups", "Settings", "Debug",null, "Windows"};
  static final boolean toolActive[] = {true, true, true,false, true};
  static final int GROUPOPT = 0;

  static final int SETTINGOPT = 1;
  static final int DEBUGOPT = 2;
  static final int DRAWBUTTERFLYOPT = 4;
    
  static final String helpMenu[] = {"About"};
  static final boolean helpActive[] = {true};
  static final int ABOUTOPT = 0;
  	
  // over-declared to make construction shorter
  static final String allMenu[][] = {fileMenu, findMenu, toolMenu, helpMenu};
  static final boolean allActive[][] = {fileActive, findActive, toolActive, helpActive};
   
  File[] files;
  TreeJuxtaposer tj_;

 
  public UI(TreeJuxtaposer tj, String title){
    tj_ = tj;

    mainFrame = new Frame(title);
    mainFrame.setLocation(10,30);
    mainFrame.setLayout(new BorderLayout());

    controlPanel = new JPanel();
    drawPanel = new Panel();

    drawLayout = new GridLayout(1,0,8,0);
 
    drawPanel.setLayout( drawLayout );
    //mainFrame.getContentPane().add(controlPanel, BorderLayout.NORTH);


    mainFrame.add(drawPanel, BorderLayout.CENTER);
    fc.addChoosableFileFilter(new NexusFilter());
    fc.addChoosableFileFilter(new NewickFilter());
    fc.setMultiSelectionEnabled(true);
    //fc.setAcceptAllFileFilterUsed(true);

    // mainFrame.setSize(300,300);
  mainFrame.addWindowListener(new WindowAdapter(){

  public void windowClosing(WindowEvent event){
    System.exit(0);
  }

  public void windowClosed(WindowEvent event){
    System.exit(0);
  }

  public void windowActivated(WindowEvent event){
  //System.out.println("window activated");
  }

  public void windowDeiconified(WindowEvent event){
    //System.out.println("window deiconified");
    tj_.requestRedrawAll();
  }

  public void windowOpened(WindowEvent event){
    tj_.requestRedrawAll();
  }

  }); // end of window adapter for main frame

    stateFrame = new StateFrame(tj_);
    settingsFrame = new SettingsFrame(tj_);
    searchFrame = new IncrementalSearch(tj_);
    debugFrame = new DebugFrame(tj_);
    butterflyFrame = new ButterflyFrame(tj_);
    addMenuBar();

    menuBar.setFont(new Font(MENUFONTTYPE, MENUFONTSTYLE, MENUFONTSIZE));
  }



   private void addMenuBar()
   {
     JPopupMenu.setDefaultLightWeightPopupEnabled(false);
     menuBar = new MenuBar();
     menuItem = new MenuItem[menuHeader.length][];
     for (int i = 0; i < menuHeader.length; i++)
     {
			menuItem[i] = new MenuItem[allMenu[i].length];
			for (int j = 0; j < allMenu[i].length; j++)
			{
				if (allMenu[i][j] == null)
					menu[i].addSeparator();
				else
				{
					menuItem[i][j] = new MenuItem(allMenu[i][j]);
					menuItem[i][j].setEnabled(allActive[i][j]);
					menu[i].add(menuItem[i][j]);
				}


			}
			menuBar.add(menu[i]);
     }
     mainFrame.setMenuBar((MenuBar)menuBar);
	
     /* Events */
     menuItem[FILEMENU][OPENOPT].addActionListener(new ActionListener()
		{ public void actionPerformed(ActionEvent e)
			{  tj_.addAction(); }});

     menuItem[FILEMENU][DELETEOPT].addActionListener(new ActionListener()
			{ public void actionPerformed(ActionEvent e)
				{  deleteAction(); }});


     menuItem[FILEMENU][QUITOPT].addActionListener(new ActionListener()
		{ public void actionPerformed(ActionEvent e)
			{  tj_.quitAction(); }});


     /* the appropriate layout of different frames
     * according to the screen size.
     */	
     menuItem[FINDMENU][FINDOPT].addActionListener(new ActionListener()
		{public void actionPerformed(ActionEvent e)
			{  
				searchFrame.setLocation(screendim.width - searchFrame.getWidth()-10, 30);
				searchFrame.show(); }});

     menuItem[TOOLMENU][GROUPOPT].addActionListener(new ActionListener()
		{public void actionPerformed(ActionEvent e)
			{  stateFrame.prepareToShow();
		
				if(mainFrame.getLocation().y + mainFrame.getHeight()+ 30 + 
				    stateFrame.getHeight() < screendim.height)


				stateFrame.setLocation(10,mainFrame.getLocation().y + mainFrame.getHeight() + 30);
                else
                stateFrame.setLocation(10,screendim.height-stateFrame.getHeight()); 
                 

				stateFrame.show(); }});


     menuItem[TOOLMENU][SETTINGOPT].addActionListener(new ActionListener()
		{public void actionPerformed(ActionEvent e)
			{  settingsFrame.prepareToShow();
                if(stateFrame.getLocation().y==30) // default loaction for stateFrame
                settingsFrame.setLocation(10, screendim.height - settingsFrame.getHeight()-30);
                else if((screendim.height < mainFrame.getHeight()+ stateFrame.getHeight()+ settingsFrame.getHeight()) ||
				(screendim.height < stateFrame.getLocation().y + stateFrame.getHeight()+ settingsFrame.getHeight()))


				settingsFrame.setLocation(20+stateFrame.getWidth(), stateFrame.getLocation().y);
            
        	    else settingsFrame.setLocation(10, stateFrame.getLocation().y + stateFrame.getHeight());

				settingsFrame.show(); }});


     menuItem[TOOLMENU][DEBUGOPT].addActionListener(new ActionListener()
		{public void actionPerformed(ActionEvent e)
			{   
				if (settingsFrame.getLocation().y == 30)
				    debugFrame.setLocation(10+settingsFrame.getWidth(), screendim.height-debugFrame.getHeight()-30);

				else if(screendim.width < settingsFrame.getLocation().x + settingsFrame.getWidth() + debugFrame.getWidth())
					
				debugFrame.setLocation(settingsFrame.getLocation().x, settingsFrame.getLocation().y - debugFrame.getHeight() );


				 else debugFrame.setLocation(10 + settingsFrame.getLocation().x + settingsFrame.getWidth(), settingsFrame.getLocation().y);


				 debugFrame.show(); }});
				 
	menuItem[TOOLMENU][DRAWBUTTERFLYOPT].addActionListener(new ActionListener()
			{public void actionPerformed(ActionEvent e)
				{   
					butterflyFrame.setLocation(520,30);

					 butterflyFrame.show(); }});

     menuItem[HELPMENU][ABOUTOPT].addActionListener(new ActionListener()
		{public void actionPerformed(ActionEvent e)
			{  new Help().showAboutFrame(); }});
	
					
     }

    protected Frame getMainFrame(){
		return mainFrame;
	}


	protected Panel getDrawPanel(){
		return drawPanel;
	}


	protected JPanel getControlPanel(){
		return controlPanel;
	}


	protected GridLayout getDrawLayout(){
		return drawLayout;
	}


   protected IncrementalSearch getSearchFrame(){
		return searchFrame;
	}


    protected SettingsFrame getSettingsFrame(){
    	return settingsFrame;
    }


    protected DebugFrame getDebugFrame(){
    	return debugFrame;
    }


    protected StateFrame getStateFrame(){
    	return stateFrame;
    }

    protected ButterflyFrame getButterflyFrame(){
    	return butterflyFrame;
    }

	protected void addAction()
		{
			//fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
			
			if(firstTime) {
				fc.setCurrentDirectory(new File("."));
				firstTime = false;
			} 
			int returnVal = fc.showOpenDialog(mainFrame);

			if (returnVal == JFileChooser.APPROVE_OPTION) {
//				File file = fc.getSelectedFile();
//				File[] files = fc.getSelectedFiles();
                files=fc.getSelectedFiles();
        	for(int i =0; i<files.length; i++){

				boolean nexus_file;
				String s = null;
				// It would be better to rely on the parser to
				// figure out the format of the file. The one
				// implemented here is an ad-hoc solution.
				//if(fc.getFileFilter().accept(files[i])) 
				if(fc.getFileFilter().getDescription().equals(Utils.nexus_file_description))
				nexus_file = true;
				else 
				nexus_file = false;
				try {
//				s = file.getCanonicalPath();
				s=files[i].getCanonicalPath();
				System.out.println("YZ File.getCanonicalPath() fname: " + s);
				if(!nexus_file) {
					System.out.println("Load newick file "+s);
					tj_.loadNewickTree(s);
				} else {
					System.out.println("Load nexus file "+s);
					tj_.loadNexusTree(s, null);
				}
				} catch (Exception ex) {
				System.out.println("File not found: " + s);
				}
	          }
			}		
			tj_.mainFrame.setVisible(true);
		}
		
	protected void deleteAction()
			{
				// fc.setCurrentDirectory(new File(System.getProperty("user.dir")));
		
/*				int returnVal = fc.showDialog(mainFrame, "delete");

				if (returnVal == JFileChooser.APPROVE_OPTION) {
//					File file = fc.getSelectedFile();
					File[] deleteFiles = fc.getSelectedFiles();
				for(int i =0; i<deleteFiles.length; i++){

					boolean nexus_file;
					String s = null;
					if(fc.getFileFilter().getDescription().equals(Utils.nexus_file_description)) 
					nexus_file = true;
					else 
					nexus_file = false;
					try {
                    s=deleteFiles[i].getCanonicalPath();
                    tj_.deleteTree(s);
	
					} catch (Exception ex) {
					System.out.println("File not found: " + s);
					}
				  }
				}		
*/
                TreeRemovalPanel trp = new TreeRemovalPanel(tj_);
                trp.pack();
                trp.setLocation(500,0);
                trp.show();
                
			}		
		
	protected void quitAction()
		{
			// add other actions if needed when the quit menu option is selected
			System.exit(0);
		}
	
	
}
